

	; Adds "level beaten" and "Yoshi Coins collected" icons
	; to the overworld map
	; 2014/15 by WYE

	; Specify levels with no yoshi coins
	; or levels that display nothing
	; in the tables at the bottom



	!TranslevelNumber	= $58		;    Will hold the level number of the current tile
						;    for easier access
						;    (the default address should be fine)

	!FrameTile1		= $40		; \
	!FrameTile2		= $41		;  |
	!ExitTileEmpty		= $2E		;  | Tiles
	!ExitTileFull		= $4C		;  |
	!YoshiCoinTileEmpty	= $64		;  |
	!YoshiCoinTileFull	= $66		; /

	!FrameProps		= $36		; \
	!ExitProps		= $36		;  | Properties
	!YoshiCoinProps		= $38 		; /





macro drawTile(x, y, tile, props)
	JSR FindFreeOAMSlot
	LDA <x>
	STA $0200,x
	LDA <y>
	STA $0201,x
	LDA <tile>
	STA $0202,x
	LDA <props>
	STA $0203,x
	PHX
	TXA : LSR #2 : TAX
	LDA #$02
	STA $0420,x
	PLX
endmacro





org $0485C5
	autoclean JML ShowIcons



freecode
ShowIcons:

	JSL $00CEB1
	PHA : PHX : PHY : PHP : SEP #$20

	LDA $13D9				; \
	CMP #$03				;  | Do nothing if not on a level tile
	BNE .return				; /

	LDA #$10				; \  Disable translucency
	TRB $40					; /  of palettes C-F

	JSR GetLevelNumberFromOW
	STA !TranslevelNumber

	JSR CheckIfDisableLevel			; \
	BEQ + : JMP .return : +			;  | Determine whether to display
	JSR CheckIfNoYoshiCoinLevel		;  | the checkmark and the Yoshi Coin icon,
	BEQ +					;  | just the checkmark,
	JSR .drawExitTile			;  | or nothing at all
	BRA .return				;  |
+	JSR .drawExitAndYoshiCoinTile		; /

.return
	PLP : PLY : PLX : PLA
	JML $0485C9



	; ###########################
	; # Draw just the checkmark #
	; ###########################

.drawExitTile

	LDX #$FC

	%drawTile(#$DA, #$2A, #!FrameTile1, #!FrameProps)
	%drawTile(#$DD, #$2A, #!FrameTile1, #!FrameProps|$40)

	PHX : LDX $58
	LDA $1EA2,x
	BPL ..notBeaten
	PLX
	%drawTile(#$DC, #$2A, #!ExitTileFull, #!ExitProps)
	RTS
..notBeaten
	PLX
	%drawTile(#$DC, #$2A, #!ExitTileEmpty, #!ExitProps)

	RTS



	; ##############################################
	; # Draw the checkmark and the Yoshi Coin icon #
	; ##############################################

.drawExitAndYoshiCoinTile

	LDX #$FC

	%drawTile(#$C6, #$2A, #!FrameTile1, #!FrameProps)
	%drawTile(#$D1, #$2A, #!FrameTile2, #!FrameProps)
	%drawTile(#$DD, #$2A, #!FrameTile1, #!FrameProps|$40)

	PHX : LDX $58
	LDA $1EA2,x
	BPL ..notBeaten
	PLX
	%drawTile(#$C8, #$2A, #!ExitTileFull, #!ExitProps)
	BRA +
..notBeaten
	PLX
	%drawTile(#$C8, #$2A, #!ExitTileEmpty, #!ExitProps)
+

	LDA $58
	JSR GetYoshiCoinStatus
	BEQ ..notAllYoshiCoins
	%drawTile(#$D9, #$2A, #!YoshiCoinTileFull, #!YoshiCoinProps)
	BRA +
..notAllYoshiCoins
	%drawTile(#$D9, #$2A, #!YoshiCoinTileEmpty, #!YoshiCoinProps)
+

	RTS





	; ###############
	; # Subroutines #
	; ###############

GetLevelNumberFromOW:

	REP #$30
	LDX $0DD6
	LDA $1F1F,x
	STA $00
	LDA $1F21,x
	STA $02
	TXA : LSR #2 : TAX

	PHK
	PEA.w .jslrtsreturn-1
	PEA.w $048E48-1
	JML $049885
.jslrtsreturn

	LDX $04
	LDA $7ED000,x
	SEP #$30

	RTS



GetYoshiCoinStatus:

	PHX
	PHY
	PHA
	LSR #3
	TAY
	PLA
	AND #$07
	TAX
	LDA $1F2F,y
	PLY
	AND.l $0DA8A6,x
	BEQ .notAll
.all
	PLX
	LDA #$01
	RTS
.notAll
	PLX
	LDA #$00
	RTS



FindFreeOAMSlot:

	TXA
	BEQ .break
.loop
	LDA $0201,x
	CMP #$F0
	BEQ .break
	DEX #4
	BNE .loop
.break
	RTS



CheckIfDisableLevel:
	LDX.b #DisableLevels_end-DisableLevels
.loop
	TXA
	BEQ .false
	DEX
	LDA.l DisableLevels,x
	CMP !TranslevelNumber
	BNE .loop
.true
	LDA #$01
.false
	RTS



CheckIfNoYoshiCoinLevel:
	LDX.b #NoYoshiCoinLevels_end-NoYoshiCoinLevels
.loop
	TXA
	BEQ .false
	DEX
	LDA.l NoYoshiCoinLevels,x
	CMP !TranslevelNumber
	BNE .loop
.true
	LDA #$01
.false
	RTS





	; ###################################################
	; # Tables (edit these, add more numbers as needed) #
	; # Translevel format (subtract $DC if >= $101)     #
	; ###################################################

; Levels on which to disable the counter entirely

DisableLevels:
	db $00
.end



; Levels that don't have Yoshi Coins

NoYoshiCoinLevels:
	db $00
.end


